import { CodeMaker } from 'codemaker';
import { ProviderSchema } from './provider-schema';
export declare class TerraformProviderConstraint {
    cdktfConstraint: string;
    version: string;
    source?: string;
    name: string;
    fqn: string;
    constructor(cdktfConstraint: string);
    isMatching(terraformSchemaName: string): boolean;
}
interface ProviderData {
    name: string;
    source: string;
    version: string;
}
export interface ProviderConstraints {
    [fqn: string]: ProviderData;
}
export declare class TerraformGenerator {
    private readonly code;
    private providerConstraints?;
    private resourceParser;
    private resourceEmitter;
    private structEmitter;
    constructor(code: CodeMaker, schema: ProviderSchema, providerConstraints?: TerraformProviderConstraint[] | undefined);
    save(outdir: string): Promise<void>;
    private emitProvider;
    private emitIndexFile;
    private emitResourceFile;
    private emitFileHeader;
}
export {};
